--## WCFilter - Settings.lua written by Burgus ##--
-- Set Default settings
local stmp = true;
if playerAlign == 2 then stmp = false; end;
defaultSettings = {
	icon = true;
	inini = stmp;
	sell = stmp;
	give = stmp;
	valar = stmp;
	buy = stmp;
	search = stmp;
	exchange = stmp;
    icombat = stmp;
	invert = false;
	group = false;
	kinship = false;
	craft = false;
	chelp = false;
	mp = false;
	links = false;
	higb = false;
	exfilter = false;
	infilter = false;
	exfpattern = "";
	infpattern = "";
	blstate = false;
	wlstate = false;
	blacklist = "";
	whitelist = "";
	plng = PLang;
};
DeepTableCopy(defaultSettings, settings);

--## Functions for Load and Save Data ##--
function SaveSettings(silent,server)
	local DSV = "";
	-- Workaround for Turbine localization bug
	local saveData = ExportTable(settings);
	-- ^^end
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Save(DSV, sfile, saveData, function() if (server == true) then sset = 1; end; end);
	if (silent == false) then write("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dstxt..".</rgb>"); end;
end
function LoadSettings(silent,server,init)
	local DSV = "";
	if (server == true) then DSV = Turbine.DataScope.Server; else DSV = Turbine.DataScope.Character; end
	Turbine.PluginData.Load(DSV, sfile, function(loadedData)
		if (loadedData) then
			-- Workaround for Turbine localization bug
			loadedData = ImportTable(loadedData);
			DeepTableCopy(loadedData, settings)
			-- ^^end
			if (server == true) then sset = 1;  end;
			if (init == false) then
				oP:SetWantsUpdates(false);
				if (not oP) then
					GetOptionsPanel(); 
				else
					UpdateOPStates(server); 
				end;
				oP:SetWantsUpdates(true);
				DoCallbacks(oP, SChng);
			end;
			if (silent == false) and (init == false) then write("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dltxt..".</rgb>"); end;
		elseif (server == false) then SaveSettings(true,false);
		end
	end);
end
-- reset to defaults
function RPrefs()
	DeepTableCopy(defaultSettings, settings);
	UpdateOPStates(false);
	write(wcol1..WCFLangData.drtxt..wcol0);
	DoCallbacks(oP, SChng);
end;
-- load and save serverwide prefs
function LSPrefs(save)
	if (save) then
		SaveSettings(true,true);
		oP.loadButton:SetEnabled(true);
		SetMenuEntry(3, true)
		write(wcol1..WCFLangData.spsave..wcol0);
	else
		LoadSettings(true,true,false);
		write(wcol1..WCFLangData.spload..wcol0);
	end;
end;

-- Disable CheckButton
function DisCB(cButton,state,blue)
	cButton:SetEnabled(state);
	if (state == true) then
		if (blue) then cButton:SetForeColor(color(0.3, 0.7, 1));
		elseif (cButton == oP.invert) then cButton:SetForeColor(color(0.6, 0.7, 1));
		else cButton:SetForeColor(color(1, 1, 1));
		end;
	else cButton:SetForeColor(color(0.3, 0.3, 0.3));
	end;
end;
-- Disable/Enable for Monsterplay and Instance/Combat
function DisMP(state)
	if not (state) then state = false; end;
	if (playerAlign == 1) then z, zs = 2, 24
	else z, zs = 1, 20
	end;
	repeat
		local obj = select(z,oP.inini,oP.invert,oP.sell,oP.give,oP.valar,oP.buy,oP.search,oP.exchange,oP.group,oP.kinship,oP.craft,oP.chelp,oP.mp,oP.links,oP.higb,oP.infilter,oP.infpattern,oP.wlstate,oP.whitelist,oP.blstate,oP.blacklist,oP.exfilter,oP.exfpattern);
		DisCB(obj,state);
		z = z + 1
	until z == zs;
	if (playerAlign == 2) then
		oP.sbar:SetEnabled(false);
		oP.plang:SetText(WCFLangData.disabled);
		oP.plang:SetForeColor(color(1, 0.3, 0.2));
	end;
end;

-- check if serverwide-prefs are available
LoadSettings(true,true,true);

-- function for updating the optionspanel
function UpdateOPStates(server)
	--## Setting the states ##--
	if (playerAlign == 1) then oP.sbar:SetValue(settings.plng); oP.plang:SetText(select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt)); end;
	oP.icon:SetChecked(settings.icon);
	oP.inini:SetChecked(settings.inini);
	oP.icombat:SetChecked(settings.icombat);
	oP.invert:SetChecked(settings.invert);
    oP.sell:SetChecked(settings.sell);
	oP.give:SetChecked(settings.give);
	oP.valar:SetChecked(settings.valar);	    
    oP.buy:SetChecked(settings.buy);
	oP.search:SetChecked(settings.search);
	oP.exchange:SetChecked(settings.exchange);
	oP.group:SetChecked(settings.group);
	oP.kinship:SetChecked(settings.kinship);
	oP.craft:SetChecked(settings.craft);
	oP.chelp:SetChecked(settings.chelp);
	oP.mp:SetChecked(settings.mp);
	oP.links:SetChecked(settings.links);
	oP.higb:SetChecked(settings.higb);
	oP.exfilter:SetChecked(settings.exfilter);
	oP.infilter:SetChecked(settings.infilter);
	oP.blstate:SetChecked(settings.blstate);
	oP.wlstate:SetChecked(settings.wlstate);
	oP.exfpattern:SetText(settings.exfpattern);
	oP.infpattern:SetText(settings.infpattern);
	oP.blacklist:SetText(settings.blacklist);
	oP.whitelist:SetText(settings.whitelist);
	if (not server) and (fstate == false) then oP.pause:SetChecked(true); else oP.qpause:SetChecked(false); end;
	if (not server) and (cstate == false) then oP.qpause:SetChecked(true); else oP.pause:SetChecked(false); end;
	if (server == true) then write("<rgb=#DAA5DA>WCF-Data "..WCFLangData.dltxt..".</rgb>"); end;
end

-- Draw the optionpanel
GetOptionsPanel();

-- Create the "options" tab in the plugin manager.
plugin.GetOptionsPanel = function()
	return oP;
end
